import React from 'react';
import { Emitter, EventType, Handler } from 'mitt';

type Events = Record<EventType, unknown>;
/** Return the event emitter. */
declare function useBus(): Emitter<Events>;
/**
 * Attach an event listener to the bus while this component is mounted.
 *
 * Adds the listener after mount, and removes it before unmount.
 */
declare function useListener(name: EventType, listener: Handler): void;
/**
 * Create an event emitter that will be available to all deeply nested child elements using the useBus() hook.
 */
declare function Provider({ children }: {
    children: React.ReactNode;
}): JSX.Element;

export { Provider, useBus, useListener };
