"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.tsx
var react_bus_exports = {};
__export(react_bus_exports, {
  Provider: () => Provider,
  useBus: () => useBus,
  useListener: () => useListener
});
module.exports = __toCommonJS(react_bus_exports);
var import_react = __toESM(require("react"));
var import_mitt = __toESM(require("mitt"));
var BusContext = import_react.default.createContext(null);
function useBus() {
  const bus = import_react.default.useContext(BusContext);
  if (!bus) throw new Error("useBus: missing context");
  return bus;
}
function useListener(name, listener) {
  const bus = useBus();
  import_react.default.useEffect(() => {
    bus.on(name, listener);
    return () => {
      bus.off(name, listener);
    };
  }, [bus, name, listener]);
}
function Provider({ children }) {
  const [bus] = import_react.default.useState(() => (0, import_mitt.default)());
  return /* @__PURE__ */ import_react.default.createElement(BusContext.Provider, { value: bus }, children);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Provider,
  useBus,
  useListener
});
